#ifndef DISTINCTELEMENTSPRIMITIVE_H
#define DISTINCTELEMENTSPRIMITIVE_H

#include <set>
#include <functional>

#include "../hashing/hashfunction.h"

namespace CluE
{

/**
 * @brief Count distinct elements in a stream using a std::set (for debugging)
 */
template<typename U, typename H> class DistinctElementsPrimitive
{

public:
	DistinctElementsPrimitive(unsigned long long sizeOfUniverse, double eps, std::function<HashFunction<U,H>*(unsigned long long sizeOfHashingSpace)> hashfunctionCreator) :
		elements()
	{
	}
	
	~DistinctElementsPrimitive()
	{
	}

	DistinctElementsPrimitive<U,H>& operator<<(U const & element);

	unsigned long long numberOfDistinctElements();

private:
	std::set<U> elements;
};

template<typename U, typename H> DistinctElementsPrimitive<U,H>& DistinctElementsPrimitive<U,H>::operator<<(U const & element)
{
	elements.insert(element);
	return *this;
}

template<typename U, typename H> unsigned long long DistinctElementsPrimitive<U,H>::numberOfDistinctElements()
{	
	return elements.size();
}

}

#endif
