#ifndef CLUEDISTRIBUTION_H
#define CLUEDISTRIBUTION_H

/**
* @brief namespace for the CluE library
*/
namespace CluE
{

/**
 * @brief Abstract base class for probability distributions.
 * 
 * @ingroup distribution_classes
 */
template<typename T>
class Distribution
{
public:
	virtual ~Distribution()
	{
	}

	/**
	 * @brief Evaluates the density function for the given T.
	 */
	virtual double density(T const& x) const = 0;	
};

}

#endif
