#include <math.h>

#include "../distribution/unigauss.h"

using namespace CluE;

UniGauss::UniGauss(double m, double v) : mean(m),variance(v)
{
	if (!(this->variance>0))
		this->variance=1/(2*M_PI);
}

double UniGauss::density(double const& x) const
{
	return (1/sqrt(2*M_PI*this->variance))*exp(-pow(x-this->mean,2)/(2*this->variance));
}
