#ifndef FREQUENCYCENTROID_H
#define FREQUENCYCENTROID_H

#include "../base/proxygenerator.h"
#include "../frequency/frequencydistribution.h"

#include <vector>

namespace CluE
{

/**
* @brief weighted centroid for FrequencyDistribution
*
* ProxyGenerator<FrequencyDistribution> class computing a weighted centroid for a vector of
* @ref FrequencyDistribution objects.
*/
class FrequencyCentroid : public ProxyGenerator<FrequencyDistribution>
{
public:
    virtual FrequencyCentroid* clone() const;

	/**
	* Generates the centroid for the given vector of @ref FrequencyDistribution objects by passing
	* the vector to the FrequencyDistribution constructor.
	* @result FrequencyDistribution as returned by the constructor.
	*/
    virtual FrequencyDistribution generate(std::vector<FrequencyDistribution*> const&) const;
};

}

#endif
