#ifndef FREQUENCYKLD_H
#define FREQUENCYKLD_H

#include "../base/dissimilaritymeasure.h"
#include "../frequency/frequencydistribution.h"

namespace CluE
{

/**
* @brief kullback-leibler divergence for FrequencyDistribution
*
* DissimilarityMeasure<FrequencyDistribution> class computing the kullback-leibler divergence
* between @ref FrequencyDistribution objects.
*/
class FrequencyKLD : public DissimilarityMeasure<FrequencyDistribution>
{
public:
	virtual FrequencyKLD* clone() const;

	/**
	* Computes the kullback-leibler divergence between the two given @ref FrequencyDistribution
	* objects.
	*
	* @return The kullback-leibler divergence between the two given @ref FrequencyDistribution
	* objects.
	*/
    virtual double dissimilarity(FrequencyDistribution const&, FrequencyDistribution const&) const;
};

}

#endif
