#include "../misc/flippinggraycodebits.h"

namespace CluE
{

GraycodeSequence::GraycodeSequence()
{
	currentPosition.push_back(1);
	startElement.push_back(0);
	currentElement = 0;
	gcs=0;
}

GraycodeSequence::~GraycodeSequence()
{
	if(this->gcs != 0)
		delete this->gcs;
}


size_t GraycodeSequence::next()
{
	size_t result = next(0);
	currentElement = result;
	
	return result;
}

size_t GraycodeSequence::next(size_t index)
{
	size_t result;
	switch(currentPosition[index])
	{
		case 0:
		case 2:
			result = startElement[index];
			break;
		case 1:
			result = startElement[index]+1;
			break;
		case 3:
			if(startElement.size()-1 == index)
			{
				size_t start = startElement[index] + 2;
				startElement.push_back(start);
				currentPosition.push_back(0);
			}
			result = next(index+1);
			break;
	}
	currentPosition[index] = (currentPosition[index]+1) % 4;

	return result;
}

size_t GraycodeSequence::current() const
{
	return currentElement;
}

}
