#ifndef FLIPPINGGRAYCODEBITS_H
#define FLIPPINGGRAYCODEBITS_H

#include <cstring>
#include <vector>

namespace CluE
{
/**
 * @brief Returns the bits flipped in a Graycode sequence.
 * 
 * First numbers of a Graycode sequence: 000, 001 -> 0,011 -> 1, 010 -> 0, 110 -> 2, 111 -> 0, 101 -> 1, ...
 * Algorithm output is: 0,1,0,2,0,1,...
 */
class GraycodeSequence
{
public:
	GraycodeSequence();
	virtual ~GraycodeSequence();
	
	/**
	 * @brief Returns the index of the next flipping bit.
	 */
	size_t next();
	
	/**
	 * @brief Returns the index of the current flipping bit.
	 */
	size_t current() const;
private:
	GraycodeSequence(size_t start);
	GraycodeSequence* gcs;
	
	size_t next(size_t index);
	
	std::vector<size_t> startElement;
	std::vector<int> currentPosition;
	size_t currentElement;
};
}

#endif
