#ifndef L1METRIC_H
#define L1METRIC_H

#include "../base/dissimilaritymeasure.h"
#include "../point/point.h"

namespace CluE
{

/**
 * @brief L1 metric for Point
 *
 * @ingroup pointrelated_classes
 */
class L1Metric : public DissimilarityMeasure<Point>
{
public:
	virtual L1Metric* clone() const;

	/**
	 * @brief Computes the l1-distance between the two given Point instances.
     */
	virtual double dissimilarity(Point const&, Point const&) const;
};

}

#endif