#ifndef LPMETRIC_H
#define LPMETRIC_H

#include "../base/dissimilaritymeasure.h"
#include "../point/point.h"

namespace CluE
{

/**
 * @brief Lp metric for Point
 * @remarks Use L1Metric / L2Metric instead of setting p=1 / p=2.
 * 
 * @ingroup pointrelated_classes
 */
class LPMetric : public DissimilarityMeasure<Point>
{
public:
	LPMetric(double p);

	virtual LPMetric* clone() const;

	/**
	 * @brief Computes the Lp-distance between the two given Point instances.
	 */
	virtual double dissimilarity(Point const&, Point const&) const;

	/**
	 * @brief Sets p ("Lp distance").
	 */
	void setP(double p);

private:
	double p;
};

}

#endif
