#ifndef SQUAREDL1METRIC_H
#define SQUAREDL1METRIC_H

#include "../base/dissimilaritymeasure.h"
#include "../point/point.h"

namespace CluE
{

/**
 * @brief Squared L1 metric for Point.
 * 
 * @ingroup pointrelated_classes
 */
class SquaredL1Metric : public DissimilarityMeasure<Point>
{
public:
	virtual SquaredL1Metric* clone() const;

	/**
	* Computes the squared l1-distance between the two given Point instances.
	*/
	virtual double dissimilarity(Point const&, Point const&) const;
};

}

#endif
