#include "algorithmtest.h"

#include <point/pointcentroid.h>

namespace CluE
{

void AlgorithmTest::setupEpsilonApproximationTest(unsigned int laps, double optimalCost, double propability, double epsilon)
{
	epsilonAppLaps = laps;
	epsilonAppOptimalCost = optimalCost;
	epsilonAppPropability = propability;
	epsilonAppEpsilon = epsilon;
}

bool AlgorithmTest::doEpsilonApproximationTest()
{
	unsigned int success = 0;
	for(unsigned int i = 0; i < epsilonAppLaps; i++)
	{
		if(i != 0)
			runAlgorithm(false);

		if(lastCost <= (1+epsilonAppEpsilon) * epsilonAppOptimalCost)
			success++;
	}

	double rate = double(success) / double(epsilonAppLaps);
	output << "Success rate: " << rate << " (minimum: " << epsilonAppPropability << ")" << std::endl;
	return epsilonAppPropability < rate;
}

}
