#ifndef FILEREADER_H
#define FILEREADER_H

#include <string>
#include <vector>
#include <map>

#include "exceptions.h"
#include <point/point.h>

namespace CluE
{

class FileReader
{
public:
    FileReader(std::string path);

    bool hasValue(std::string key);
    std::string getValue(std::string key, bool toLower = true);

    static std::vector<CluE::Point*> readPointFile(std::string path);
	
	bool getConfigFlag(std::string key);
	std::string getConfigString(std::string key, bool toLower = true);
	unsigned int getConfigUInt(std::string key);
	double getConfigDouble(std::string key);
private:
    std::map<std::string, std::string> keyvalue;
};

}

#endif
