#include "helper.h"

#include <boost/algorithm/string.hpp>
#include <boost/test/floating_point_comparison.hpp>

using std::string;
using std::endl;
using std::vector;

namespace CluE
{

Helper::Helper()
{
}

Helper::~Helper()
{
}

vector<unsigned int> Helper::convertToUIntSequence(string val) {
	vector<string> stringseq;
	boost::split(stringseq, val, boost::is_any_of(","), boost::token_compress_on);

	vector<unsigned int> uintseq;
	size_t n = stringseq.size();
	for(size_t i = 0; i < n; i++)
		uintseq.push_back(static_cast<unsigned int>(std::atoi(stringseq[i].c_str())));

	return uintseq;
}

vector<double> Helper::convertToDoubleSequence(string val) {
	vector<string> stringseq;
	boost::split(stringseq, val, boost::is_any_of(","), boost::token_compress_on);

	vector<double> doubleseq;
	size_t n = stringseq.size();
	for(size_t i = 0; i < n; i++)
		doubleseq.push_back(static_cast<double>(std::atof(stringseq[i].c_str())));

	return doubleseq;
}

bool Helper::equalsDouble(double a, double b)
{
	static boost::test_tools::close_at_tolerance<double> comp(boost::test_tools::percent_tolerance_t<double>(0.0001));
	return comp(a,b);
}

}

